diff -ruN ../nakedmudv2.7/src/Makefile src/Makefile
--- ../nakedmudv2.7/src/Makefile	Sun Jul 31 17:17:07 2005
+++ src/Makefile	Fri Oct  7 14:22:56 2005
@@ -1,7 +1,7 @@
 ###############################################################################
 # makefile for nakedmud
 #
-# many thanks go out to Tyche for suggesting I read "Recursive Make Considered
+# Thanks go out to Tyche for bringing my attention to "Recursive Make Considered
 # Harmful" by Peter Miller. Many of the make conventions used in this makefile
 # were taken from Miller's article. The reference is:
 # 
@@ -48,10 +48,11 @@
 	   log.c auxiliary.c account_handler.c char_gen.c \
 	   \
 	   world.c character.c room.c exit.c extra_descs.c object.c body.c \
-	   zone.c dialog.c room_reset.c account.c \
+	   zone.c room_reset.c account.c \
 	   \
 	   list.c property_table.c hashtable.c map.c storage.c set.c \
-	   buffer.c bitvector.c numbers.c
+	   buffer.c bitvector.c numbers.c prototype.c hooks.c parse.c \
+	   near_map.c command.c
 
 
 # include the description for each module. These will add to SRC
diff -ruN ../nakedmudv2.7/src/account.c src/account.c
--- ../nakedmudv2.7/src/account.c	Sun Jul 31 17:13:54 2005
+++ src/account.c	Fri Oct  7 14:15:55 2005
@@ -14,6 +14,7 @@
 //*****************************************************************************
 
 #include "mud.h"
+#include "utils.h"
 #include "auxiliary.h"
 #include "storage.h"
 #include "account.h"
@@ -127,7 +128,7 @@
 
 void accountSetPassword(ACCOUNT_DATA *account, const char *password) {
   if(account->password) free(account->password);
-  account->password = strdup(password ? password : "");
+  account->password = strdupsafe(password);
 }
 
 const char *accountGetPassword(ACCOUNT_DATA *account) {
@@ -136,7 +137,7 @@
 
 void accountSetName(ACCOUNT_DATA *account, const char *name) {
   if(account->name) free(account->name);
-  account->name = strdup(name ? name : "");
+  account->name = strdupsafe(name);
 }
 
 const char *accountGetName(ACCOUNT_DATA *account) {
diff -ruN ../nakedmudv2.7/src/account_handler.c src/account_handler.c
--- ../nakedmudv2.7/src/account_handler.c	Sun Jul 31 17:13:54 2005
+++ src/account_handler.c	Fri Oct  7 14:15:55 2005
@@ -13,17 +13,14 @@
 #include "socket.h"
 #include "account.h"
 #include "character.h"
+#include "room.h"
 #include "inform.h"
 #include "save.h"
 #include "char_gen.h"
+#include "hooks.h"
 
 
 
-//*****************************************************************************
-// mandatory modules
-//*****************************************************************************
-#include "scripts/script.h"
-
 // mccp support
 const unsigned char do_echo   [] = { IAC, WONT, TELOPT_ECHO,      '\0' };
 const unsigned char dont_echo [] = { IAC, WILL, TELOPT_ECHO,      '\0' };
@@ -101,7 +98,7 @@
     log_string("Account '%s' is trying to connect.", arg);
 
     // check for new account
-    if ( (acct = load_account(arg)) == NULL) {
+    if ( (acct = get_account(arg)) == NULL) {
       // check for lockdown
       if(*mudsettingGetString("lockdown") &&
 	 !is_keyword(mudsettingGetString("lockdown"), DFLT_USER_GROUP, FALSE)) {
@@ -110,6 +107,13 @@
 	return;
       }
 
+      // make sure someone else is not creating an account with this name
+      if(account_creating(arg)) {
+	text_to_socket(sock, "Someone is already creating an account with "
+		       "that name.\r\nTry again: ");
+	return;
+      }
+
       // make a new account and give it a name
       acct = newAccount();
       accountSetName(acct, arg);
@@ -183,8 +187,12 @@
 	       accountGetPassword(socketGetAccount(sock)))) {
     text_to_buffer(sock, (char *)do_echo);
 
-    // account created. Save it, and plop it into the account menu
-    save_account(socketGetAccount(sock));
+    // account created. Register it, and plop it into the account menu. If it
+    // is already created, we're just editing the password. So save changes.
+    if(!account_exists(accountGetName(socketGetAccount(sock))))
+      register_account(socketGetAccount(sock));
+    else
+      save_account(socketGetAccount(sock));
     socketReplaceInputHandler(sock, account_handle_menu, account_menu);
   }
   else {
@@ -220,7 +228,7 @@
     }
 
     // hmmm... our pfile is missing!!
-    else if ((ch = load_player(ch_name)) == NULL)
+    else if ((ch = get_player(ch_name)) == NULL)
       text_to_socket(sock, "ERROR: Your pfile is missing!\n\r");
 
     // everything is OK
@@ -233,7 +241,7 @@
       if(*mudsettingGetString("lockdown") &&
 	 !bitIsSet(charGetUserGroups(ch), mudsettingGetString("lockdown"))) {
 	send_to_char(ch, "You are currently locked out of the mud.\r\n");
-	deleteChar(ch);
+	unreference_player(ch);
 	socketSetChar(sock, NULL);
 	return;
       }
@@ -246,17 +254,17 @@
 	// input handler
 	socketPushInputHandler(sock, handle_cmd_input, show_prompt);
 
-	text_to_buffer(sock, motd);
+	text_to_buffer(sock, bufferString(motd));
 	look_at_room(ch, charGetRoom(ch));
 
-	// check enterance scripts
-	try_enterance_script(ch, charGetRoom(ch), NULL);
+	// run entrance hooks
+	hookRun("enter", ch, charGetRoom(ch), NULL);
       }
       else {
 	text_to_buffer(sock, "There was a problem entering the game. Try again later!\r\n");
 	// do not extract, just delete. We failed to enter
 	// the game, so there is no need to extract from the game.
-	deleteChar(socketGetChar(sock));
+	unreference_player(socketGetChar(sock));
 	socketSetChar(sock, NULL);
       }
     }
diff -ruN ../nakedmudv2.7/src/action.c src/action.c
--- ../nakedmudv2.7/src/action.c	Sun Jul 31 17:13:54 2005
+++ src/action.c	Fri Oct  7 14:15:55 2005
@@ -32,6 +32,7 @@
 #include "utils.h"
 #include "character.h"
 #include "action.h"
+#include "hooks.h"
 
 #ifdef MODULE_FACULTY
 #include "faculty/faculty.h"
@@ -52,9 +53,7 @@
 
 
 //*****************************************************************************
-//
 // A small test for delayed actions ... proof of concept
-//
 //*****************************************************************************
 void do_dsay(CHAR_DATA *ch, void *data, bitvector_t where, char *arg) {
   communicate(ch, arg, COMM_LOCAL);
@@ -76,9 +75,7 @@
 
 
 //*****************************************************************************
-//
 // single action handling
-//
 //*****************************************************************************
 ACTION_DATA *newAction(int delay, 	
 		       bitvector_t where,
@@ -90,7 +87,7 @@
   action->on_interrupt = on_interrupt;
   action->delay        = delay;
   action->data         = data;
-  action->arg          = strdup(arg ? arg :"");
+  action->arg          = strdupsafe(arg);
   action->where        = where;
   return action;
 }
@@ -115,22 +112,26 @@
 #endif
 }
 
+// stop_all_actions as a hook
+void stop_all_actions_hook(CHAR_DATA *ch, void *none1, void *none2) {
+  stop_all_actions(ch);
+}
+
+
 
 //*****************************************************************************
-//
 // actor list handling
-//
 //*****************************************************************************
 void init_actions() {
   // use the standard pointer hasher and comparator
   actors = newMap(NULL, NULL);
 
   // add in our example delayed action
-  add_cmd("dsay", NULL, cmd_dsay, 0, POS_SITTING, POS_FLYING, 
+  add_cmd("dsay", NULL, cmd_dsay, POS_SITTING, POS_FLYING, 
 	  "admin", TRUE, FALSE);
 
   // make sure the character does not continue actions after being extracted
-  add_extract_mob_func(stop_all_actions);
+  hookAdd("char_from_game", stop_all_actions_hook);
 }
 
 bool is_acting(void *ch, bitvector_t where) {
diff -ruN ../nakedmudv2.7/src/alias/alias.c src/alias/alias.c
--- ../nakedmudv2.7/src/alias/alias.c	Sun Jul 31 17:13:52 2005
+++ src/alias/alias.c	Fri Oct  7 14:15:55 2005
@@ -30,15 +30,13 @@
 
 ALIAS_AUX_DATA *
 newAliasAuxData() {
-  ALIAS_AUX_DATA *data = malloc(sizeof(ALIAS_AUX_DATA));
+  ALIAS_AUX_DATA *data = calloc(1, sizeof(ALIAS_AUX_DATA));
   //
   // Hashtables can take up lots of storage space. Because of this, let's
   // not create any tables until it's actually needed. This will cut down
   // on lots of memory usage w.r.t. NPCs who do not use aliases
   //  data->aliases        = newHashtable();
   //
-  data->aliases        = NULL;
-  data->alias_queue    = 0;
   return data;
 }
 
@@ -286,12 +284,12 @@
 				       aliasAuxDataStore, aliasAuxDataRead));
 
   // allow people to view their aliases
-  add_cmd("alias", NULL, cmd_alias, 0, POS_UNCONCIOUS, POS_FLYING, 
+  add_cmd("alias", NULL, cmd_alias, POS_UNCONCIOUS, POS_FLYING, 
 	  "player", FALSE, TRUE);
 }
 
 
-bool try_alias(CHAR_DATA *ch, char *command, char *arg, bool scripts_ok) {
+bool try_alias(CHAR_DATA *ch, char *command, char *arg) {
   // is this command from an alias that executes multi commands?
   // if it is, don't let it trigger any further aliases, or else we might
   // get stuck in an infinite loop
@@ -327,7 +325,7 @@
 	charSetAliasesQueued(ch, num_cmds);
       }
       if(num_cmds > 0)
-	do_cmd(ch, cmds[0], scripts_ok, FALSE);
+	do_cmd(ch, cmds[0], FALSE);
       
       // clean up our mess
       for(i = 0; i < num_cmds; i++)
diff -ruN ../nakedmudv2.7/src/alias/alias.h src/alias/alias.h
--- ../nakedmudv2.7/src/alias/alias.h	Sun Jul 31 17:13:52 2005
+++ src/alias/alias.h	Fri Oct  7 14:15:55 2005
@@ -22,7 +22,7 @@
 //
 // tries to treat the command as an alias. If we succeed, return true. In this
 // case, the function calling this one should terminate
-bool try_alias(CHAR_DATA *ch, char *command, char *arg, bool scripts_ok);
+bool try_alias(CHAR_DATA *ch, char *command, char *arg);
 
 //
 // for use by socket.c to see if we need to do anything special w/ aliases
diff -ruN ../nakedmudv2.7/src/auxiliary.c src/auxiliary.c
--- ../nakedmudv2.7/src/auxiliary.c	Sun Jul 31 17:13:54 2005
+++ src/auxiliary.c	Fri Oct  7 14:15:55 2005
@@ -99,7 +99,7 @@
 
 HASHTABLE *
 newAuxiliaryData(bitvector_t aux_type) {
-  HASHTABLE        *data = newHashtableSize(25);
+  HASHTABLE        *data = newHashtable();
   HASH_ITERATOR  *hash_i = newHashIterator(auxiliary_manip_funcs);
   AUXILIARY_FUNCS *funcs = NULL;
   const char       *name = NULL;
@@ -176,7 +176,7 @@
 
 HASHTABLE *
 auxiliaryDataRead(STORAGE_SET *set, bitvector_t aux_type) {
-  HASHTABLE        *data = newHashtableSize(25);
+  HASHTABLE        *data = newHashtable();
   HASH_ITERATOR  *hash_i = newHashIterator(auxiliary_manip_funcs);
   AUXILIARY_FUNCS *funcs = NULL;
   const char       *name = NULL;
@@ -234,7 +234,7 @@
 
 HASHTABLE *
 auxiliaryDataCopy(HASHTABLE *data) {
-  HASHTABLE *newdata = newHashtableSize(25);
+  HASHTABLE *newdata = newHashtableSize(hashSize(data));
   auxiliaryDataCopyTo(data, newdata);
   return newdata;
 }
diff -ruN ../nakedmudv2.7/src/bitvector.c src/bitvector.c
--- ../nakedmudv2.7/src/bitvector.c	Sun Jul 31 17:13:52 2005
+++ src/bitvector.c	Fri Oct  7 14:15:55 2005
@@ -81,7 +81,6 @@
   // and also create some of the basic bitvectors and 
   // bits that come stock and are required for the core release
   bitvectorCreate("char_prfs");
-  bitvectorAddBit("char_prfs", "buildwalk");
 
   bitvectorCreate("obj_bits");
   bitvectorAddBit("obj_bits", "notake");
diff -ruN ../nakedmudv2.7/src/buffer.c src/buffer.c
--- ../nakedmudv2.7/src/buffer.c	Sun Jul 31 17:13:52 2005
+++ src/buffer.c	Fri Oct  7 14:15:55 2005
@@ -33,7 +33,7 @@
 }
 
 void        deleteBuffer(BUFFER *buf) {
-  free(buf->data);
+  if(buf->data) free(buf->data);
   free(buf);
 }
 
@@ -61,17 +61,14 @@
 }
 
 BUFFER    *bufferCopy  (BUFFER *buf) {
-  BUFFER *newbuf = newBuffer(buf->maxlen);
-  memcpy(newbuf->data, buf->data, buf->maxlen);
-  newbuf->len = buf->len;
+  BUFFER *newbuf = newBuffer(1);
+  bufferCopyTo(buf, newbuf);
   return newbuf;
 }
 
 void        bufferCopyTo(BUFFER *from, BUFFER *to) {
-  free(to->data);
-  to->data   = strdup(from->data);
-  to->len    = from->len;
-  to->maxlen = from->maxlen;
+  bufferClear(to);
+  bufferCat(to, bufferString(from));
 }
 
 const char *bufferString(BUFFER *buf) {
@@ -282,7 +279,7 @@
 	col = 0;
       }
       // indent two spaces if we're not at the start of a line 
-      else if(needs_indent && buf_i-1 >= 0 && buf->data[buf_i-1] != '\n') {
+      else if(needs_indent && col != 0) {
 	formatted[fmt_i] = ' '; fmt_i++;
 	formatted[fmt_i] = ' '; fmt_i++;
 	col += 2;
diff -ruN ../nakedmudv2.7/src/char_gen.c src/char_gen.c
--- ../nakedmudv2.7/src/char_gen.c	Sun Jul 31 17:13:52 2005
+++ src/char_gen.c	Fri Oct  7 14:15:55 2005
@@ -19,18 +19,13 @@
 #include "socket.h"
 #include "account.h"
 #include "character.h"
+#include "room.h"
 #include "world.h"
 #include "save.h"
 #include "races.h"
 #include "handler.h"
 #include "inform.h"
-
-
-
-//*****************************************************************************
-// mandatory modules
-//*****************************************************************************
-#include "scripts/script.h"
+#include "hooks.h"
 
 
 
@@ -77,11 +72,18 @@
     text_to_buffer(sock, 
 		   "Sorry, that was an illegal name. Please pick another.\r\n"
 		   "What is your name? ");
+
   // a character with this name already exists
-  else if(char_exists(arg))
+  else if(player_exists(arg))
     text_to_buffer(sock,
 		   "A character with this name already exists.\r\n"
 		   "What is your name? ");
+
+  // someone's already creating a character with this name
+  else if(player_creating(arg))
+    text_to_buffer(sock, "Someone is already creating a player with that name."
+		   "\r\nTry again: ");
+
   // we're OK to make this new character
   else {
     ch = newChar();
@@ -160,14 +162,14 @@
     // pop the input handler for char creation and add the one for
     // playing the game
     socketReplaceInputHandler(sock, handle_cmd_input, show_prompt);
-    text_to_buffer(sock, motd);
+    text_to_buffer(sock, bufferString(motd));
     
     // we should do some checks here to make sure the start room exists
     char_to_room(socketGetChar(sock), worldGetRoom(gameworld, START_ROOM));
     look_at_room(socketGetChar(sock), charGetRoom(socketGetChar(sock)));
     
-    // and save him 
-    save_player(socketGetChar(sock));
+    // and register him as a valid player
+    register_player(socketGetChar(sock));
     
     //************************************************************
     //******                 VERY IMPORTANT                 ******
@@ -176,8 +178,9 @@
     accountPutChar(socketGetAccount(sock), charGetName(socketGetChar(sock)));
     save_account(socketGetAccount(sock));
 
-    // check enterance scripts
-    try_enterance_script(socketGetChar(sock), charGetRoom(socketGetChar(sock)), NULL);
+    // run entrance hooks
+    ROOM_DATA      *room = charGetRoom(socketGetChar(sock));
+    hookRun("enter", socketGetChar(sock), room, NULL);
   }
 }
 
diff -ruN ../nakedmudv2.7/src/char_vars/char_vars.c src/char_vars/char_vars.c
--- ../nakedmudv2.7/src/char_vars/char_vars.c	Sun Jul 31 17:13:51 2005
+++ src/char_vars/char_vars.c	Fri Oct  7 14:15:55 2005
@@ -41,7 +41,7 @@
 
 CHAR_VAR *newCharVarString(const char *str) {
   CHAR_VAR *data = malloc(sizeof(CHAR_VAR));
-  data->str_val  = strdup(str ? str : "");
+  data->str_val  = strdupsafe(str);
   data->type     = CHAR_VAR_STRING;
   return data;
 }
diff -ruN ../nakedmudv2.7/src/character.c src/character.c
--- ../nakedmudv2.7/src/character.c	Sun Jul 31 17:13:52 2005
+++ src/character.c	Fri Oct  7 14:15:55 2005
@@ -15,10 +15,8 @@
 #include "utils.h"
 #include "body.h"
 #include "races.h"
-#include "handler.h"
 #include "auxiliary.h"
 #include "storage.h"
-#include "room.h"
 #include "character.h"
 
 
@@ -90,16 +88,19 @@
 
 struct char_data {
   // data for PCs only
-  int              loadroom;
+  char                 * loadroom;
 
   // shared data for PCs and NPCs
   int                    uid;
 
   BODY_DATA            * body;
   char                 * race;
+  char                 * prototypes;
+  char                 * class;
 
   SOCKET_DATA          * socket;
   ROOM_DATA            * room;
+  ROOM_DATA            * last_room;
   OBJ_DATA             * furniture;
   BUFFER               * desc;
   char                 * name;
@@ -112,24 +113,23 @@
   BITVECTOR            * user_groups;
 
   // data for NPCs only
-  int            dialog;
   char                 * rdesc;
   char                 * multi_name;
   char                 * multi_rdesc;
   char                 * keywords;
-  int               vnum;  
 };
 
 
 CHAR_DATA *newChar() {
   CHAR_DATA *ch   = calloc(1, sizeof(CHAR_DATA));
 
-  ch->loadroom      = NOWHERE;
+  ch->loadroom      = strdup("");
   ch->uid           = NOBODY;
 
-  ch->race          = strdup(raceDefault());//RACE_HUMAN;
+  ch->race          = strdup(raceDefault());
   ch->body          = raceCreateBody(ch->race);
   ch->room          = NULL;
+  ch->last_room     = NULL;
   ch->furniture     = NULL;
   ch->socket        = NULL;
   ch->desc          = newBuffer(1);
@@ -138,12 +138,12 @@
   ch->position      = POS_STANDING;
   ch->inventory     = newList();
 
+  ch->class         = strdup("");
+  ch->prototypes    = strdup("");
   ch->rdesc         = strdup("");
   ch->keywords      = strdup("");
   ch->multi_rdesc   = strdup("");
   ch->multi_name    = strdup("");
-  ch->dialog        = NOTHING;
-  ch->vnum          = NOBODY;
   ch->prfs          = bitvectorInstanceOf("char_prfs");
   ch->user_groups   = bitvectorInstanceOf("user_groups");
   bitSet(ch->user_groups, DFLT_USER_GROUP);
@@ -156,23 +156,25 @@
 
 
 //*****************************************************************************
-//
 // utility functions
-//
 //*****************************************************************************
 void charSetRdesc(CHAR_DATA *ch, const char *rdesc) {
   if(ch->rdesc) free(ch->rdesc);
-  ch->rdesc =   strdup(rdesc ? rdesc : "");
+  ch->rdesc =   strdupsafe(rdesc);
 }
 
 void charSetMultiRdesc(CHAR_DATA *ch, const char *multi_rdesc) {
   if(ch->multi_rdesc) free(ch->multi_rdesc);
-  ch->multi_rdesc =   strdup(multi_rdesc ? multi_rdesc : "");
+  ch->multi_rdesc =   strdupsafe(multi_rdesc);
 }
 
 void charSetMultiName(CHAR_DATA *ch, const char *multi_name) {
   if(ch->multi_name) free(ch->multi_name);
-  ch->multi_name =   strdup(multi_name ? multi_name : "");
+  ch->multi_name =   strdupsafe(multi_name);
+}
+
+bool charIsInstance(CHAR_DATA *ch, const char *prototype) {
+  return is_keyword(ch->prototypes, prototype, FALSE);
 }
 
 bool charIsNPC( CHAR_DATA *ch) {
@@ -188,25 +190,35 @@
 
 
 //*****************************************************************************
-//
 // set and get functions
-//
 //*****************************************************************************
 LIST        *charGetInventory ( CHAR_DATA *ch) {
   return ch->inventory;
-};
+}
 
 SOCKET_DATA *charGetSocket    ( CHAR_DATA *ch) {
   return ch->socket;
-};
+}
 
 ROOM_DATA   *charGetRoom      ( CHAR_DATA *ch) {
   return ch->room;
-};
+}
+
+ROOM_DATA *charGetLastRoom(CHAR_DATA *ch) {
+  return ch->last_room;
+}
+
+const char *charGetClass(CHAR_DATA *ch) {
+  return ch->class;
+}
+
+const char  *charGetPrototypes( CHAR_DATA *ch) {
+  return ch->prototypes;
+}
 
 const char  *charGetName      ( CHAR_DATA *ch) {
   return ch->name;
-};
+}
 
 const char  *charGetDesc      ( CHAR_DATA *ch) {
   return bufferString(ch->desc);
@@ -230,12 +242,11 @@
 
 int         charGetSex        ( CHAR_DATA *ch) {
   return ch->sex;
-};
-
+}
 
 int         charGetPos        ( CHAR_DATA *ch) {
   return ch->position;
-};
+}
 
 BODY_DATA   *charGetBody      ( CHAR_DATA *ch) {
   return ch->body;
@@ -249,7 +260,7 @@
   return ch->uid;
 }
 
-int    charGetLoadroom (CHAR_DATA *ch) {
+const char *charGetLoadroom (CHAR_DATA *ch) {
   return ch->loadroom;
 }
 
@@ -271,41 +282,57 @@
 
 void         charSetSocket    ( CHAR_DATA *ch, SOCKET_DATA *socket) {
   ch->socket = socket;
-};
+}
 
 void         charSetRoom      ( CHAR_DATA *ch, ROOM_DATA *room) {
   ch->room   = room;
-};
+}
+
+void charSetLastRoom(CHAR_DATA *ch, ROOM_DATA *room) {
+  ch->last_room = room;
+}
+
+void charSetClass(CHAR_DATA *ch, const char *prototype) {
+  if(ch->class) free(ch->class);
+  ch->class = strdupsafe(prototype);
+}
+
+void charSetPrototypes(CHAR_DATA *ch, const char *prototypes) {
+  if(ch->prototypes) free(ch->prototypes);
+  ch->prototypes = strdupsafe(prototypes);
+}
+
+void charAddPrototype(CHAR_DATA *ch, const char *prototype) {
+  add_keyword(&ch->prototypes, prototype);
+}
 
 void         charSetName      ( CHAR_DATA *ch, const char *name) {
   if(ch->name) free(ch->name);
-  ch->name = strdup(name ? name : "");
-};
+  ch->name = strdupsafe(name);
+}
 
 void         charSetSex       ( CHAR_DATA *ch, int sex) {
   ch->sex = sex;
-};
+}
 
 void         charSetPos       ( CHAR_DATA *ch, int pos) {
   ch->position = pos;
-};
+}
 
 void         charSetDesc      ( CHAR_DATA *ch, const char *desc) {
   bufferClear(ch->desc);
   bufferCat(ch->desc, (desc ? desc : ""));
-};
+}
 
 void         charSetBody      ( CHAR_DATA *ch, BODY_DATA *body) {
-  if(ch->body) {
-    unequip_all(ch);
+  if(ch->body)
     deleteBody(ch->body);
-  }
   ch->body = body;
 }
 
 void         charSetRace  (CHAR_DATA *ch, const char *race) {
   if(ch->race) free(ch->race);
-  ch->race = strdup(race);
+  ch->race = strdupsafe(race);
 }
 
 void         charSetUID(CHAR_DATA *ch, int uid) {
@@ -316,8 +343,9 @@
   charSetBody(ch, raceCreateBody(ch->race));
 }
 
-void charSetLoadroom(CHAR_DATA *ch, int loadroom) {
-  ch->loadroom = loadroom;
+void charSetLoadroom(CHAR_DATA *ch, const char *loadroom) {
+  if(ch->loadroom) free(ch->loadroom);
+  ch->loadroom = strdupsafe(loadroom);
 }
 
 void charSetFurniture(CHAR_DATA *ch, OBJ_DATA *furniture) {
@@ -345,12 +373,16 @@
   // it's also assumed we've extracted our inventory
   deleteList(mob->inventory);
 
+  if(mob->class)       free(mob->class);
+  if(mob->prototypes)  free(mob->prototypes);
   if(mob->name)        free(mob->name);
   if(mob->desc)        deleteBuffer(mob->desc);
   if(mob->rdesc)       free(mob->rdesc);
   if(mob->multi_rdesc) free(mob->multi_rdesc);
   if(mob->multi_name)  free(mob->multi_name);
   if(mob->keywords)    free(mob->keywords);
+  if(mob->loadroom)    free(mob->loadroom);
+  if(mob->race)        free(mob->race);
   if(mob->prfs)        deleteBitvector(mob->prfs);
   if(mob->user_groups) deleteBitvector(mob->user_groups);
   deleteAuxiliaryData(mob->auxiliary_data);
@@ -362,7 +394,8 @@
 CHAR_DATA *charRead(STORAGE_SET *set) {
   CHAR_DATA *mob = newMobile();
 
-  charSetVnum(mob,         read_int   (set, "vnum"));
+  charSetClass(mob,        read_string(set, "class"));
+  charSetPrototypes(mob,   read_string(set, "prototypes"));
   charSetName(mob,         read_string(set, "name"));
   charSetKeywords(mob,     read_string(set, "keywords"));
   charSetRdesc(mob,        read_string(set, "rdesc"));
@@ -373,30 +406,24 @@
   charSetRace(mob,         read_string(set, "race"));
   bitSet(mob->prfs,        read_string(set, "prfs"));
   bitSet(mob->user_groups, read_string(set, "user_groups"));
+  charSetLoadroom(mob,     read_string(set, "loadroom"));
+  charSetPos(mob,          read_int   (set, "position"));
 
   // make sure we always have the default group assigned
   if(!*bitvectorGetBits(mob->user_groups))
     bitSet(mob->user_groups, DFLT_USER_GROUP);
 
   // read in PC data if it exists
-  if(storage_contains(set, "uid")) {
+  if(storage_contains(set, "uid"))
     charSetUID(mob,        read_int   (set, "uid"));
-    charSetLoadroom(mob,   read_int   (set, "loadroom"));
-    charSetPos(mob,        read_int   (set, "position"));
-  }
-  // and NPC data
-  else
-    charSetDialog(mob,        read_int   (set, "dialog"));
 
   deleteAuxiliaryData(mob->auxiliary_data);
   mob->auxiliary_data = auxiliaryDataRead(read_set(set, "auxiliary"), 
 					  AUXILIARY_TYPE_CHAR);
 
   // make sure our race is OK
-  if(!isRace(mob->race)) {
-    free(mob->race);
-    mob->race = strdup(raceDefault());
-  }
+  if(!isRace(charGetRace(mob)))
+    charSetRace(mob, raceDefault());
 
   // reset our body to the default for our race
   charResetBody(mob);
@@ -407,7 +434,8 @@
 
 STORAGE_SET *charStore(CHAR_DATA *mob) {
   STORAGE_SET *set = new_storage_set();
-  store_int   (set, "vnum",       mob->vnum);
+  store_string(set, "class",      mob->class);
+  store_string(set, "prototypes", mob->prototypes);
   store_string(set, "name",       mob->name);
   store_string(set, "keywords",   mob->keywords);
   store_string(set, "rdesc",      mob->rdesc);
@@ -423,12 +451,8 @@
   if(!charIsNPC(mob)) {
     store_int   (set, "position",   mob->position);
     store_int   (set, "uid",        mob->uid);
-    store_int   (set, "loadroom",   (mob->room ? 
-				     roomGetVnum(mob->room) : mob->loadroom));
+    store_string(set, "loadroom",   mob->loadroom);
   }
-  // NPC-only data
-  else
-    store_int   (set, "dialog",     mob->dialog);
 
   store_set(set,"auxiliary", auxiliaryDataStore(mob->auxiliary_data));
   return set;
@@ -436,10 +460,9 @@
 
 
 void charCopyTo( CHAR_DATA *from, CHAR_DATA *to) {
-  charSetVnum    (to, charGetVnum(from));
-  charSetKeywords(to, charGetKeywords(from));
-  charSetDialog  (to, charGetDialog(from));
-
+  charSetKeywords   (to, charGetKeywords(from));
+  charSetClass      (to, charGetClass(from));
+  charSetPrototypes (to, charGetPrototypes(from));
   charSetName       (to, charGetName(from));
   charSetDesc       (to, charGetDesc(from));
   charSetRdesc      (to, charGetRdesc(from));
@@ -463,30 +486,13 @@
 }
 
 
+
 //*****************************************************************************
-//
 // mob set and get functions
-//
 //*****************************************************************************
 void charSetKeywords(CHAR_DATA *ch, const char *keywords) {
   if(ch->keywords) free(ch->keywords);
-  ch->keywords = strdup(keywords ? keywords : "");
-}
-
-void charSetVnum(CHAR_DATA *ch, int vnum) {
-  ch->vnum = vnum;
-}
-
-void charSetDialog(CHAR_DATA *ch, int vnum) {
-  ch->dialog = vnum;
-}
-
-int     charGetVnum       ( CHAR_DATA *ch) {
-  return ch->vnum;
-}
-
-int  charGetDialog     ( CHAR_DATA *ch) {
-  return ch->dialog;
+  ch->keywords = strdupsafe(keywords);
 }
 
 const char  *charGetKeywords   ( CHAR_DATA *ch) {
